#ifdef MIXER_SUPPORT

typedef struct
{	char *name;
	short	weight;
	char short_name[6];	
} mixer_weight_entry;


#ifndef SND_MIXER_GRP_SYNTH_TREBLE
#define SND_MIXER_GRP_SYNTH_TREBLE "Synth Treble"
#endif

#ifndef SND_MIXER_GRP_SYNTH_BASS
#define SND_MIXER_GRP_SYNTH_BASS "Synth Bass"
#endif



static mixer_weight_entry  alsamix_weights[] = {
	{ SND_MIXER_OUT_MASTER,		-1360,   "M.Vol"},
	{ SND_MIXER_OUT_MASTER_DIGITAL, -1350, "M.Dig"},
	{ SND_MIXER_OUT_MASTER_MONO,	-1340,   "M.Mon"},
	{ SND_MIXER_GRP_EFFECT_3D,	-1310,   "3D" },
	{ SND_MIXER_GRP_BASS,		-1300,   "Bass"},
	{ SND_MIXER_GRP_TREBLE,		-1290,   "Trebl"},
	{ SND_MIXER_GRP_EQUALIZER,	-1286,   "Eqalz"},
	{ SND_MIXER_GRP_FADER,		-1282,   "Fader"},
	{ SND_MIXER_GRP_OGAIN,		-1278,   "GainO"},
	{ SND_MIXER_GRP_IGAIN,		-1274,   "GainI"},
	{ SND_MIXER_GRP_ANALOG_LOOPBACK,-1270, "LoopA"},
	{ SND_MIXER_GRP_DIGITAL_LOOPBACK,-1265, "LoopD"},
	{ SND_MIXER_OUT_CENTER,		-1260,   "CntrI"},
	{ SND_MIXER_IN_CENTER,		-1250,   "CntrO"},
	{ SND_MIXER_OUT_WOOFER,		-1240,   "WoofI"},
	{ SND_MIXER_IN_WOOFER,		-1230,   "WoofO"},
	{ SND_MIXER_OUT_SURROUND,	-1220,   "SrndI"},
	{ SND_MIXER_IN_SURROUND,	-1210,   "SrndO"},
	{ SND_MIXER_IN_SYNTHESIZER,	-1200,   "Synth"},
	{ SND_MIXER_GRP_SYNTH_TREBLE,	-1196,   "Syn.T"},
	{ SND_MIXER_GRP_SYNTH_BASS,	-1194,   "Syn.B"},
	{ SND_MIXER_IN_FM,		-1190,   "FM I"},
	{ SND_MIXER_GRP_EFFECT,		-1180,   "Effct"},
	{ SND_MIXER_OUT_DSP,		-1170,   "DSP O"},
	{ SND_MIXER_IN_DSP,		-1160,   "DSP I"},
	{ SND_MIXER_IN_PCM,		-1150,   "PCM"},
	{ SND_MIXER_IN_DAC,		-1140,   "DAC"},
	{ SND_MIXER_IN_LINE,		-1130,   "Line"},
	{ SND_MIXER_IN_MIC,		-1120,   "Mic"},
	{ SND_MIXER_IN_CD,		-1110,   "CD" },
	{ SND_MIXER_IN_VIDEO,		-1100,   "Video"},
	{ SND_MIXER_IN_RADIO,		-1090,   "Radio"},
	{ SND_MIXER_IN_PHONE,		-1080,   "PhonI"},
	{ SND_MIXER_OUT_HEADPHONE,	-1076,   "Phon1"},
	{ SND_MIXER_OUT_PHONE,		-1074,   "Phon2"},
	{ SND_MIXER_GRP_MIC_GAIN,	-1070,   "GainM"},
	{ SND_MIXER_IN_SPEAKER,		-1020,   "Spkr"},
	{ SND_MIXER_IN_MONO,		-1010,   "Mono"},
	{ SND_MIXER_IN_AUX,		-1000,   "AuxI" },
	{ NULL, 0, "" }
};

#endif

